"""GLiCID spawner module."""

from batchspawner import SlurmSpawner
from jinja2 import Environment, PackageLoader, select_autoescape

from .pyenv import get_pyenv


class GlicidSpawner(SlurmSpawner):
    """Glicid SLURM Spawner."""

    def _options_form_default(self) -> str:
        """JupyterHub rendered form template."""
        environment = Environment(
            loader=PackageLoader('glicid_spawner'),
            autoescape=select_autoescape(),
        )
        template = environment.get_template('interactive.html')

        return template.render(
            username=self.user.name,
            python_envs=get_pyenv(self.user.name),
        )

    def options_from_form(self, formdata) -> dict:
        options = {}
        options['pyenv'] = formdata['python-env'][0]
        return options
